%
% άɢ Poisson 
% CG 
%
% function Poisson_CG

clear all;
close all;

tol = 10e-6; % ֹ
a = 0; b = 1;
N = 32; h = 1/(N+1); 
n = N*N;
maxit = n;

T1D = 2*eye(N) - diag(ones(N-1,1),1) - diag(ones(N-1,1),-1);
A = kron(eye(N),T1D) + kron(T1D,eye(N));  % ϵ

uxy = @(x,y) sin(2*pi*x).*sin(3*pi*y);
fxy = @(x,y) 13*pi*pi*sin(2*pi*x).*sin(3*pi*y);
[X,Y] = meshgrid(a+h:h:b-h);
xt = uxy(X,Y); xt = xt(:);
b = h*h*fxy(X,Y); b = b(:);  % Ҷ
b = A*xt;

x0 = randn(n,1);  % ֵ

% %%%% MATLAB Դ CG 
% [x, flag, relres, iter, resvec] = pcg(A,b,tol,maxit,[],[],x0);
% fprintf('pcg : iter = %d, relerr = %.4e\n', iter, relres );
% figure(1)
% semilogy(1:length(resvec), resvec,'--+b');  
% title('CG convergence history')
% figure(2)
% mesh(X, Y, reshape(x,N,N))
% return

% CG 
x = x0;
r = b - A*x;
beta = norm(b);  
resvec = []; %%%%% ¼ÿ
for k = 1 : maxit   
   rho = dot(r,r);
   if ( k > 1 )               
      mu = rho / rho_0;
      p = r + mu*p;
   else
      p = r;
   end
   q = A*p;
   xi = rho / dot(p,q);
   x = x + xi*p;                  
   r = r - xi*q;         
   relres = norm(r) / beta;    
   resvec(k+1) = relres;  %%%%% ¼ÿ
   % fprintf(' iter=%d, relres=%e\n', iter, relres);
   if (relres <= tol), break, end 
   rho_0 = rho;
end

if (k==n) 
    fprintf('CG : failure!')
else
    fprintf('CG : iter = %d, relerr = %.4e\n', k, norm(b-A*x)/norm(b) );
end

%%%% Ʋ
figure(1)
semilogy(1:length(resvec), resvec,'--+b');  
title('CG convergence history')

figure(2)
mesh(X, Y, reshape(x,N,N))


