%
% superconvergence of CG
%
clear all;
close all;

tol = 1e-12;
n = 64;
maxit = n;

[Q,R] = qr(randn(n));

xt = ones(n,1); % true solution

% 特征值均匀分布
Lambda = linspace(1,n,n);
A = Q*diag(Lambda)*Q';
b = A*xt; % right-hand side
[x, flag, relres, iter, resvec] = pcg(A,b,tol,maxit);
figure(1), subplot(2,1,1), 
plot(real(Lambda),imag(Lambda),'+b'), title('Eigenvalues (uniform)');
figure(2), semilogy(resvec/norm(b),'+:'), title('Convergence history'); 
fprintf('||x-xt||/||xt|| = %.2e\n', norm(x-xt)/norm(xt));


% 特征值聚集分布
m = 10;
Lambda = [1+(n-1)*rand(m,1); 10*ones(n-m,1)+ 1*rand(n-m,1)];
A = Q*diag(Lambda)*Q'; 
b = A*xt; % right-hand side
[x, flag, relres, iter, resvec] = pcg(A,b,tol,maxit);
figure(1), subplot(2,1,2), 
plot(real(Lambda),imag(Lambda),'or'), title('Eigenvalues (cluster)');
figure(2), hold on, semilogy(resvec/norm(b),'o:'), 
legend('uniform','cluster'); hold off; 
fprintf('||x-xt||/||xt|| = %.2e\n', norm(x-xt)/norm(xt));

