function [x,relres,iter,relvec] = FOM(A,b,tol,maxit,x0)
iter = 0;    
relres = 0.0;  
n = length(b);

r = b - A*x0;   % initial residual 
beta = norm(r); 
% fprintf('||r_0||=%e\n', beta);

relvec = 1;
V(:,1) = r/beta;
for j = 1 : maxit
    w = A*V(:,j);
    for i = 1 : j
        H(i,j) = dot(w,V(:,i));
        w = w - H(i,j)*V(:,i);
    end
    H(j+1,j) = norm(w);
    if H(j+1,j) == 0, break, end
    y = H(1:j,1:j)\(beta*eye(j,1));
    relres = H(j+1,j)*abs(y(j))/beta;
    relvec(j+1) = relres;
    if relres < tol, break, end
    V(:,j+1) = w/H(j+1,j);
end
x = x0 + V*y;
iter = j;

